#ifndef __VID_WIN_H__
#define __VID_WIN_H__
//****************************************************************************
//**
//**    VID_WIN.H
//**    Header - Windows DirectDraw
//**
//**    Copyright (c) 1998 Chris Hargrove
//**    Notice: Usage of any code in this file is subject to the rules
//**            described in the LICENSE.TXT file included in this directory.
//**            Reading, compiling, or otherwise using this code constitutes
//**            automatic acceptance of the rules in said text file.
//**
//****************************************************************************
//============================================================================
//    INTERFACE REQUIRED HEADERS
//============================================================================
#define SYS_DEFS_INCLUDE_WIN32
#include "sys_defs.h"

//============================================================================
//    INTERFACE DEFINITIONS / ENUMERATIONS / SIMPLE TYPEDEFS
//============================================================================
//============================================================================
//    INTERFACE CLASS PROTOTYPES / EXTERNAL CLASS REFERENCES
//============================================================================
//============================================================================
//    INTERFACE STRUCTURES / UTILITY CLASSES
//============================================================================
//============================================================================
//    INTERFACE DATA DECLARATIONS
//============================================================================
//============================================================================
//    INTERFACE FUNCTION PROTOTYPES
//============================================================================

// init/shutdown/frame
void VIDW_Init();
void VIDW_Shutdown();
void VIDW_Frame();

// image control
dword VIDW_LoadImage(byte* imageData, sdword width, sdword height, dword bitDepth, bbool masking);
void VIDW_FreeImage(dword imageHandle);
void VIDW_DrawImage(dword imageHandle, sdword scrX, sdword scrY);
byte* VIDW_LockImage(dword imageHandle, dword* outImgPitch);
void VIDW_UnlockImage(dword imageHandle, byte* lockPtr);
dword VIDW_GetImageWidth(dword imageHandle);
dword VIDW_GetImageHeight(dword imageHandle);
dword VIDW_GetImageBitDepth(dword imageHandle);

// video mode control
bbool VIDW_SetMode(void* mode);
bbool VIDW_SetModeEx(dword width, dword height, dword bitDepth);
dword VIDW_GetAvailableModes(void** modeList, dword maxModes);
dword VIDW_GetModeWidth(void* mode); // mode NULL denotes current video mode
dword VIDW_GetModeHeight(void* mode); // "
dword VIDW_GetModeBitDepth(void* mode); // "
char* VIDW_GetModeDeviceName(void* mode); // "
char* VIDW_GetModeDeviceDescription(void* mode); // "

// palette control
void VIDW_SetPaletteRange(byte* buffer, dword startColor, dword numColors);
void VIDW_SetPaletteEntry(byte color, byte r, byte g, byte b);
void VIDW_GetPaletteEntry(byte color, byte *r, byte *g, byte *b);

//============================================================================
//    INTERFACE OBJECT CLASS DEFINITIONS
//============================================================================
//============================================================================
//    INTERFACE TRAILING HEADERS
//============================================================================

//****************************************************************************
//**
//**    END HEADER VID_WIN.H
//**
//****************************************************************************
#endif // __VID_WIN_H__
